# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from ..core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1
from .create_event_request_body_event_type import CreateEventRequestBodyEventType
from .event_body import EventBody


class CreateEventRequestBody(pydantic_v1.BaseModel):
    body: typing.Optional[EventBody] = None
    event_type: CreateEventRequestBodyEventType = pydantic_v1.Field()
    """
    Either 'identify' or 'track'
    """

    sent_at: typing.Optional[dt.datetime] = pydantic_v1.Field(default=None)
    """
    Optionally provide a timestamp at which the event was sent to Schematic
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
