# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from ..core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1


class UpsertTraitRequestBody(pydantic_v1.BaseModel):
    incr: typing.Optional[int] = pydantic_v1.Field(default=None)
    """
    Amount to increment the trait by (positive or negative)
    """

    keys: typing.Dict[str, typing.Any] = pydantic_v1.Field()
    """
    Key/value pairs too identify a company or user
    """

    set_: typing.Optional[str] = pydantic_v1.Field(alias="set", default=None)
    """
    Value to set the trait to
    """

    trait: str = pydantic_v1.Field()
    """
    Name of the trait to update
    """

    update_only: typing.Optional[bool] = pydantic_v1.Field(default=None)
    """
    Unless this is set, the company or user will be created if it does not already exist
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        populate_by_name = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
